<?php
  /* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 1.2-4                                               |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: default.conf.php,v 1.1 2008-09-23 11:09:23 aflores@palosanto.com Exp $ */

function _moduleContent(&$smarty, $module_name)
{
    //include elastix framework
    include_once "libs/paloSantoGrid.class.php";
    include_once "libs/paloSantoForm.class.php";

    //include module files
    include_once "modules/$module_name/configs/default.conf.php";
    include_once "modules/$module_name/libs/paloSantoTexttoWav.class.php";

    $lang=get_language();
    $script_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    $lang_file="modules/$module_name/lang/$lang.lang";
    if (file_exists("$script_dir/$lang_file"))
        include_once($lang_file);
    else
        include_once("modules/$module_name/lang/en.lang");

    global $arrConf;
    global $arrConfModule;
    global $arrLang;
    global $arrLangModule;
    $arrConf = array_merge($arrConf,$arrConfModule);
    $arrLang = array_merge($arrLang,$arrLangModule);

    //folder path for custom templates
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    $templates_dir=(isset($arrConf['templates_dir']))?$arrConf['templates_dir']:'themes';
    $local_templates_dir="$base_dir/modules/$module_name/".$templates_dir.'/'.$arrConf['theme'];

    $accion = getAction();

    $content = "";
    switch($accion){
        case "generate":
            $content = generateWav($smarty, $module_name, $local_templates_dir, $arrLang);
            break;
        case "back":
            header("Location: ?menu=$module_name");
        default:
            $content = form_TexttoWav($smarty, $module_name, $local_templates_dir, $arrLang);
            break;
    }
    return $content;
}

function generateWav($smarty, $module_name, $local_templates_dir, $arrLang)
{
    $arrFormConference = createFieldForm($arrLang);
    $oForm = new paloForm($smarty,$arrFormConference);

    if(!$oForm->validateForm($_POST)) {
        $smarty->assign("mb_title", $arrLang["Validation Error"]);
        $arrErrores = $oForm->arrErroresValidacion;
        $strErrorMsg = "<b>{$arrLang['The following fields contain errors']}:</b><br/>";
        if(is_array($arrErrores) && count($arrErrores) > 0){
            foreach($arrErrores as $k=>$v) {
                $strErrorMsg .= "$k, ";
            }
        }
        $smarty->assign("mb_message", $strErrorMsg);
        $contenidoModulo =  form_TexttoWav($smarty, $module_name, $local_templates_dir, $arrLang);
    }else{
        $smarty->assign("GENERATE", $arrLang["Generate"]);
        $smarty->assign("BACK", $arrLang["Back"]);
        $smarty->assign("REQUIRED_FIELD", $arrLang["Required field"]);
        $smarty->assign("IMG", "images/list.png");
        $smarty->assign("FORMATO", getParameter('format'));	
        $smarty->assign("DOWNLOAD",$arrLang["Download File"]);
        $path = "var";
        $smarty->assign("PATH",$path);

        $format = getParameter('format');
        $message = stripslashes(trim(getParameter('message')));
        $message = substr($message, 0, 1024);

        $audiodir = "/var/www/html/$path";
        $oTextToWap = new paloSantoTexttoWav();
        $execute = $oTextToWap->TextoWav($audiodir, $format, $message);
        if($execute){	
            $smarty->assign("FILENAME","tts.");
            $smarty->assign("EXTENSION",getParameter('format'));
            $smarty->assign("EXECUTE",$execute);
        }
        else{
            $smarty->assign("mb_title", $arrLang["Error"]);
            $smarty->assign("mb_message", $oTextToWap->errMsg);
        }

        $htmlForm = $oForm->fetchForm("$local_templates_dir/form.tpl", $arrLang["Text to Wav"], $_POST);
        $contenidoModulo = "<form  method='POST' style='margin-bottom:0;' action='?menu=$module_name'>".$htmlForm."</form>";
  }
return $contenidoModulo;
}


function form_TexttoWav($smarty, $module_name, $local_templates_dir, $arrLang)
{
    $arrFormConference = createFieldForm($arrLang);
    $oForm = new paloForm($smarty,$arrFormConference);

    $smarty->assign("GENERATE", $arrLang["Generate"]);
    $smarty->assign("REQUIRED_FIELD", $arrLang["Required field"]);
    $smarty->assign("IMG", "images/list.png");
    $arrData['format'] = (getParameter("format"))?getParameter("format"):"wav";

    $htmlForm = $oForm->fetchForm("$local_templates_dir/form.tpl", $arrLang["Text to Wav"], $arrData);
    $contenidoModulo = "<form  method='POST' style='margin-bottom:0;' action='?menu=$module_name'>".$htmlForm."</form>";

    return $contenidoModulo;
}


function createFieldForm($arrLang)
{
     $arrOptions = array('wav' => "wav", 'gsm' => "gsm");

    $arrFields = array(
            "message"          => array(   "LABEL"                  => $arrLang["Message"],
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "TEXTAREA",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "EDITABLE"               => "si",
                                            "COLS"                   => "50",
                                            "ROWS"                   => "4",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                ),
            "format"             => array(   "LABEL"                  => $arrLang["Format"],
                                            "REQUIRED"               => "yes",
                                            "INPUT_TYPE"             => "RADIO",
                                            "INPUT_EXTRA_PARAM"      => $arrOptions,
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                ),
            );
    return $arrFields;
}

function getParameter($parameter)
{
    if(isset($_POST[$parameter]))
        return $_POST[$parameter];
    else if(isset($_GET[$parameter]))
        return $_GET[$parameter];
    else
        return null;
}

function getAction()
{
    if(getParameter("show")) //Get parameter by POST (submit)
        return "show";
    if(getParameter("generate"))
        return "generate";
	if(getParameter("back"))
        return "back";
    else if(getParameter("new"))
        return "new";
    else if(getParameter("action")=="show") //Get parameter by GET (command pattern, links)
        return "show";
    else
        return "report";
}?>
